----------------------------------------------------------------------------------
-- Background widget
-----------------------------------------------------------------------------------

ChannelList = wndNew( 'ChannelList', RootWindow, 160, 93 )

function ChannelList.actions.onCreate( win )
	logMethod( TRACE, 'onCreate', win['name'] )

	win.actions.onShow = chlistOnShow

	local bg = 'FondoListaCanales.png'

	--	Background
	local background = bgNew(
		'background',
		win.x,
		win.y,
		bg
	)
	bgAddText(background, "Canales", win.x+15, win.y + 23, 16)
	wndAddWidget( win, background )

	--	Resize window to background image
	wndResize( win, bgSize(background) ) 

	local w, h = canvas:imageSize( bg )
	local listWidth = w - 30
	local list = listNew('list', win.x+15, win.y+30, listWidth, h - 55, 20)
	listSetTopPadding( list, 8 )

	--	Channel list
	wndAddWidget( win, list )
	wdtAddAction( list, 'onElementSelected', chlistOnChannelChanged )
	win.variables.channels = list
	chlistUpdate( win )

	imgs = {
		['barTop'] = "ScrollBarritaArriba.png",
		['barMid'] = "ScrollBarritaMedio.png",
		['barBottom'] = "ScrollBarritaAbajo.png",
		['buttonUp'] = 'ScrollArriba.png',
		['buttonUpSel'] = 'ScrollArriba.png',
		['buttonDown'] = 'ScrollAbajo.png',
		['buttonDownSel'] = 'ScrollAbajo.png'
	}

	local scrollbarHeight = 14
	local scrollbar = scrollbarNew("scrollbar", scrollbarHeight, list, imgs)
	--	scrollbar for channel list
	wndAddWidget(
		win,
		scrollbar
	)

	listSetSelectedColor(list, 22, 182, 241, 255)
	listSetSelectedWidth(list, listWidth - scrollbarHeight -6)

	--	Forward keys
	--	Setup keys: Forward toggle list actions
	win.keys.Release = {
		  [KEY_SMALL_L] = 'onMenuClose',
		  [KEY_EXIT] = 'onMenuClose',
		  [KEY_ESCAPE] = 'onMenuClose'
	}

end

function ChannelList.actions.onMenuClose( wdt )
	wdtSetVisible( wdt, false )
end

function chlistUpdate( chlist )
	logMethod( TRACE, 'chlistUpdate', chlist.name )
	local chs = channels.getAll()
	local elements = {}
	local selected
	local currentChannel = channel.current()

	for i=1, #chs do
		local elem = chs[i]
		if currentChannel  == elem.channelID then
			selected = i
		end
		elem.tostring = function() return elem.channel .. "  " .. elem.name end
		elements[i] = elem
	end
	listContent( chlist.variables.channels, elements, selected)
end

function chlistOnShow( chlist )
	chlistUpdate( chlist )
	winOnShow( chlist )
end

function chlistOnChannelChanged( list, selected )
	logMethod( TRACE, 'chlistOnChannelChanged', selected.tostring() )
	changeChannel( selected.channelID )
end

function toggleChannelList()
	ChannelList.actions['onClose'] = nil
	wdtSetParent( ChannelList, RootWindow )
	wdtToggleVisible( ChannelList )
end
