----------------------------------------------------------------------------------
-- Root Window
-----------------------------------------------------------------------------------

RootWindow = wndNew( 'Root', nil, 0, 0 )

function RootWindow.actions.onCreate( win )
	--	Resize
	wndResize( RootWindow, canvas.size() )

	--	Setup keys
	win.keys.Press = {
		  [KEY_CHANNEL_UP]   = 'onChannelUp'
		, [KEY_SMALL_Q]      = 'onChannelUp'
		, [KEY_CURSOR_RIGHT] = 'onChannelUp'
		, [KEY_CHANNEL_DOWN] = 'onChannelDown'
		, [KEY_SMALL_Z]      = 'onChannelDown'
		, [KEY_CURSOR_LEFT]  = 'onChannelDown'

		, [KEY_MUTE]         = 'onMute'
		, [KEY_SMALL_M]      = 'onMute'
		, [KEY_VOLUME_UP]    = 'onVolUp'
		, [KEY_SMALL_W]      = 'onVolUp'
		, [KEY_VOLUME_DOWN]  = 'onVolDown'
		, [KEY_SMALL_X]      = 'onVolDown'

		, [KEY_MENU]         = 'onToggleMenu'
		, [KEY_SMALL_C]      = 'onToggleMenu'

		, [KEY_SMALL_R]      = 'onScan'
	
		, [KEY_EXIT]         = 'onExit'
		, [KEY_ESCAPE]       = 'onExit'
	
		, [KEY_SUBTITLE]     = 'onToggleSub'
		, [KEY_SMALL_S]      = 'onToggleSub'
		, [KEY_AUDIO]        = 'onNextAudio'
		, [KEY_SMALL_A]      = 'onNextAudio'

		, [KEY_SMALL_F]      = 'onToggleFullScreen'
	}

	win.keys.Release = {
		  [KEY_SMALL_L]      = 'onToggleChannelList'
	}
end

function RootWindow.actions.onButton()
	wdtToggleVisible( MenuWindow )
end

function RootWindow.actions.onChannelUp()
	changeFactor(1)
end

function RootWindow.actions.onChannelDown()
	changeFactor(-1)
end

function RootWindow.actions.onMute()
	toggleMute()
end

function RootWindow.actions.onVolUp()
	volumenUp()
end

function RootWindow.actions.onVolDown()
	volumenDown()
end

function RootWindow.actions.onToggleSub()
	nextSubtitle()
end

function RootWindow.actions.onNextAudio()
	nextAudio()
end

function RootWindow.actions.onToggleMenu()
	wdtToggleVisible( MenuWindow )
end

function RootWindow.actions.onToggleFullScreen()
	toogleFullScreen()
end

function RootWindow.actions.onToggleChannelList()
	toggleChannelList()
end

function RootWindow.actions.onScan( win )
	logMethod( TRACE, 'OnScan' )
	startScan( win )
end

function RootWindow.actions.onExit()
	log( TRACE, 'On exit!' )
	exitLoop()
end

