---------------------------------------------------------------------------------
-- Constans
-----------------------------------------------------------------------------------

FALSE = 0
TRUE  = 1

INFO = 1
DEBUG = 2
TRACE = 3

---------------------------------------------------------------------------------
-- Variables
-----------------------------------------------------------------------------------

local DEBUG_LEVEL = INFO

---------------------------------------------------------------------------------
-- Methods
-----------------------------------------------------------------------------------

-- LOG
function log( level, str )
	if ( DEBUG_LEVEL >= level ) then
		print( '[lua] ' .. str )
	end
end

function logMethod( verb_level, func, ... )
	local str = func .. '( '

	-- Loop arguments
	for i = 1, #arg do
		str = str .. tostring(arg[i])
		str = str .. ' '
	end
	str = str .. ')'
	log( verb_level, str )
end

function traceback ()
	local level = 1
	while true do
		local info = debug.getinfo(level, "Sl")
		if not info then break end
		if info.what == "C" then   -- is a C function?
			print(level, "C function")
		else   -- a Lua function
			print(string.format("[lua] [%s]: %d", info.short_src, info.currentline))
		end
		level = level + 1
	end
end

function getFont ()
	return 'Helvetica'
end

