print( "[lua] init" )

-- Libs
require "util"                 -- Aux functions
require "widgets/widget"      -- Widget functions
require "widgets/button"      -- Button functions
require "widgets/window"      -- Window functions
require "widgets/progressbar" -- ProgressBar functions
require "widgets/background"  -- Background functions
require "widgets/list"        -- List functions
require "widgets/slider"      -- Slider functions
require "widgets/scrollbar"   -- Scrollbar functions

-- Implementation
require "root"                 -- root window
require "menu"                 -- menu window
require "scan"                 -- scan window
require "channellist"          -- channel list window
require "downloadapplication"  -- download application widget
require "about"                -- about window

require "model" -- model methods


--------------------------------------------------------------------------------------------------
-- Main
--------------------------------------------------------------------------------------------------

-- Cache fonts
canvas:cacheFonts( getFont() )

-- Create windows
wdtCreate( RootWindow )
wdtCreate( MenuWindow )
wdtCreate( ChannelList )
wdtCreate( ScanWindow )
wdtCreate( DownloadAppWidget )
wdtCreate( AboutWindow )

-- Show root window (transparent)
wdtToggleVisible( RootWindow )

-- If no channels, show splash
if (channels.haveChannels() == 0) then
	log( INFO, "Sin canales!" )
	mainWindow.showBackground(1)
	wdtToggleVisible( MenuWindow )
	canvas:flush()
end

-- Run main loop
mainWindow.run()

log( INFO, "exit" )

