----------------------------------------------------------------------------------
-- Background widget
-----------------------------------------------------------------------------------

function bgOnShow( bg )
	canvas:drawImage( bg.img, bg.x, bg.y )

	for i=1, #bg.txts do
		label = bg.txts[i]

		if (label.color ~= nil) then
			canvas:setColor( label.color.r, label.color.g, label.color.b, label.color.a )
		else
			canvas:setColor( 0, 0, 0, 255 )
		end

		if (label.size ~= nil) then
			canvas:setFont( getFont(), label.size )
		end

		if (label.w ~= nil and label.h ~= nil ) then
			canvas:drawText( label.txt, label.x, label.y, label.w, label.h )
		else
			canvas:drawText( label.txt, label.x, label.y)
		end
	end
end

function bgOnHide( bg )
	local w,h = canvas:imageSize( bg.img )
	canvas:clear( bg.x, bg.y, w, h )
end

function bgNew( name, x, y, img )
	local bg = wdtNew( name, nil, x, y, 'Background' )
	bg.img = img
	bg.actions.onShow = bgOnShow;
	bg.actions.onHide = bgOnHide;
	bg.actions.onCreate = emptyMethod
	
	bg.txts = {}
	
	return bg
end

function bgAddText( bg, txt, x, y, size, color )
	label = { txt = txt, x = x, y = y, size = size, color = color }
	table.insert(bg.txts, label)
end

function bgAddBoundedText( bg, txt, x, y, w, h, size, color )
	label = { txt = txt, x = x, y = y, w = w, h = h, size = size, color = color }
	table.insert(bg.txts, label)
end

function bgSize( bg )
	return canvas:imageSize( bg.img )
end
