--------------------------------------
-- Widget ProgressBar
--------------------------------------

function pbOnShow( pb )
	logMethod( TRACE, 'pbOnShow', pb['name'] )
	bgOnShow( pb.background )
	pbDrawPercentage( pb )
	pbDrawLabel( pb )
end

function pbOnHide( pb )
	logMethod( TRACE, 'pbOnHide', pb['name'] )
	bgOnHide( pb.background )
end

-- 0 <= percentage <= 100
function pbUpdate( pb, percentage, label )
	logMethod( TRACE, 'pbUpdate', pb['name'], percentage, label )
	pb.value = percentage / 100.0;
	if (label ~= nil) then
		pb.label.text = label
	end
	if (pb.visible) then
		pbOnShow( pb )
	end
end

function pbNew( name, x, y, backImg,
		label, labelSize, labelPosX, labelPosY,
		progressRectX, progressRectY, progressRectW, progressRectH )

	local pb = wdtNew( name, nil, x, y, 'ProgressBar' )
	pb.value = 0
	pb.background = bgNew( name .. '_bg', x, y, backImg )

	pb.label = {
		['text'] = label,
		['size'] = labelSize,

		['pos'] = {
			['x'] = labelPosX,
			['y'] = labelPosY
		},

		['color'] = {
			['r'] = 0,
			['g'] = 0,
			['b'] = 0,
			['alpha'] = 255
		}
	}

	pb.progressRect = {
		['rect'] = {
			['x'] = progressRectX,
			['y'] = progressRectY,
			['w'] = progressRectW,
			['h'] = progressRectH
		},

		['color'] = {
			['r'] = 0,
			['g'] = 127,
			['b'] = 255,
			['alpha'] = 255
		}
	}

	pb.actions.onShow = pbOnShow
	pb.actions.onHide = pbOnHide
	pb.actions.onCreate = emptyMethod

	return pb
end

-- Private functions

function pbDrawLabel( pb )
	canvas:setColor( pb.label.color.r, pb.label.color.g, pb.label.color.b, pb.label.color.alpha )
	canvas:setFont( getFont(), pb.label.size )
	canvas:drawText( pb.label.text, pb.label.pos.x + pb.x, pb.label.pos.y + pb.y )
end

function pbDrawPercentage( pb )
	canvas:setColor( pb.progressRect.color.r, pb.progressRect.color.g, pb.progressRect.color.b, pb.progressRect.color.alpha )
	canvas:fillRect(
		pb.x+pb.progressRect.rect.x,
		pb.y+pb.progressRect.rect.y,
		pb.progressRect.rect.w * pb.value,
		pb.progressRect.rect.h
	)
end
